/*****************************************
Quelltexte zum Buch: Praxisbuch Wicket
(http://www.hanser.de/978-3-446-41909-4)

Autor: Michael Mosmann
(michael@mosmann.de)
*****************************************/
package de.wicketpraxis.web.blog.pages;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.markup.html.list.ListItem;
import org.apache.wicket.markup.html.list.ListView;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;

import de.wicketpraxis.web.blog.pages.questions.checkgroup.fromdb.CheckGroupFromDbPage;
import de.wicketpraxis.web.blog.pages.questions.listview.ajax.ListViewAjaxRefreshPage;
import de.wicketpraxis.web.blog.pages.questions.migration.forms.KomplexFormPage;
import de.wicketpraxis.web.blog.pages.questions.migration.forms.MinimalFormPage;
import de.wicketpraxis.web.blog.wicketstuff.StuffPage;

public class Start extends WebPage
{
	public Start()
	{
		List<Class<? extends WebPage>> pages = new ArrayList<Class<? extends WebPage>>();
		pages.add(CheckGroupFromDbPage.class);
		pages.add(ListViewAjaxRefreshPage.class);
		pages.add(MinimalFormPage.class);
		pages.add(KomplexFormPage.class);
		pages.add(StuffPage.class);
		
		add(new ListView<Class<? extends WebPage>>("list",pages)
		{
			@Override
			protected void populateItem(ListItem<Class<? extends WebPage>> item)
			{
				BookmarkablePageLink<WebPage> link = new BookmarkablePageLink<WebPage>("link",item.getModelObject());
				link.add(new Label("name",item.getModelObject().getSimpleName()));
				item.add(link);
			}
		});
	}
}
